/*
 * PM - 2016
 * lab0.c
 */

#include <avr/io.h>
#include <util/delay.h>
#include <avr/interrupt.h>
#include <stdio.h>
#include "lcd.h"

#define AREF 5
#define REFERENCE_DC_LOOP_RESISTANCE 0.188 // 0.188 ohm/m

char mess_cable_is_wired[] = "Cable is wired:";
char mess_dc_loop_resistance[] = "DC Resistance:";
char mess_press_again[] = "Press again";
char mess_for_new_test[] = "for new test";
char mess_short_circuited[] = "short-circuited" ;

volatile unsigned int debounce = 0;
volatile unsigned int status = 0;
//0 daca nu are un scurt, 1 daca are
volatile unsigned int shorted_cable = 0;

//numar conexiuni bune
unsigned char good_paths = 0;

//conexiuni bune in raport cu standardul T568B, indexul fiind in raport cu portul B,adica primul fir care intra in PB 0 si PA 0 este portocaliu cu alb
char good_connections[8] = {0};

unsigned int shorted_paths[2] = {0};


ISR(PCINT3_vect)
{
	// momentan e facut ca daca se apasa PD5, atunci se stinge led-ul
    if((PIND & (1 << PD6)) == 0) {
    
		
		while ((PIND & (1 << PD6)) == 0) {
		
		}
		//	debounce++;
		_delay_ms(500);
			//if (debounce == 10 ) {

		DDRD |= (1 << PD7);
		//PORTD |= (1 << PD7);
		//_delay_ms(1000);
		PORTD &= ~(1 << PD7);
		//_delay_ms(1000);
		status += 1;
			//	break;
			//}
		//}
		//debounce = 0;
    }
	
}

/* PORT B este mereu sender-ul, deci ar trebui facut astfel incat detectarea de straight through sau crossover sa fie in functie de pinii lui B

1. asocierea pentru straight through este:

PB 0 1 2 3 4    5 6 7

trimite catre 

PA 0 1 2 3 4 PD 0 1 4

2. asocierea pentru crossover este:

PB 0 PB	1 PB 2 PB 3 PB 4 PB 5 PB 6 PB 7

trimite catre

PA 2 PD 0 PA 0 PA 3 PA 4 PA 1 PD 1 PD 4

3. asocierea pentru rollover este: ( folosit doar pentru a interfata cu dispozitive, deci nu are sens testarea de calitate partiala pe el

PB 0 PB	1 PB 2 PB 3 PB 4 PB 5 PB 6 PB 7

PD 4 PD 1 PD 0 PA 4 PA 3 PA 2 PA 1 PA 0

*/

//initializeaza ADC
void init_adc(void)
{
	
	ADMUX = 0;
	ADMUX |= (1 << REFS0);         // AVCC with external capacitor at AREF pin
	ADCSRA = 0;
	ADCSRA |= (1 << ADPS2) | (1 << ADPS1) | (1 << ADPS0); //set clock prescaler at 128
	ADCSRA |= (1 << ADEN);    // enable ADC        
	//ADMUX = (1 << REFS0);
	//ADCSRA = (1 << ADEN) | (7 << ADPS0);
}

// intoarce valoarea masurata de ADC, in functie de tipul cablului
unsigned int get_adc_value(int type)
{
	if (type < 0) {
		return -1;
	}
	// avem straight-through
	else if (type == 1) {
		
		// seteaza PA ca input
		DDRA &= ~(1 << PA0);
		// dezactiveaza pull-up
		PORTA &= ~(1 << PA0);
		
		DDRB |= (1 << PB0);
		PORTB |= (1 << PB0);
		//porneste conversia
		ADCSRA |= (1 << ADSC); 
		// asteapta conversia
		while(ADCSRA & (1 << ADSC));
		
		//refa starea lui PA0
		PORTA |= (1 << PA0);
		return ADC;
		//ADMUX = (ADMUX & ~(0x1f << MUX0)) | channel;

		//ADCSRA |= (1 << ADSC);
		//while(ADCSRA & (1 << ADSC));

		
	}
	// avem crossover
	else if (type == 2) {
		
		// seteaza PA ca input
		// seteaza PA ca input
		DDRA &= ~(1 << PA0);
		// dezactiveaza pull-up
		PORTA &= ~(1 << PA0);
		
		DDRB |= (1 << PB2);
		PORTB |= (1 << PB2);
		//porneste conversia
		ADCSRA |= (1 << ADSC); 
		// asteapta conversia
		while(ADCSRA & (1 << ADSC));
		
		//refa starea lui PA0
		PORTA |= (1 <<PA0);
		
		return ADC;
	}
	else {
		return -1;
	}
}

double ADC_voltage(int raw)
{
	return raw * AREF / 1024.;
}

//DC current per I/O pin.................................................. 40.0mA pag 329 datasheet
double get_impedance(int type)
{
	init_adc();
	unsigned int value = get_adc_value(type);

	if (value == -1) {
		return 0;
		
	}
	double output_potential = ADC_voltage(value);
	//unsigned int integer_part_OP= (int)output_potential;
	// 1000 este precizia, adica in acest caz numarul de zerouri ( deci 3 cifre dupa virgula);
	//unsigned int fractional_part_OP = output_potential * 1000 - integer_part_OP * 1000;	
	//char buffer_2[16];
	//sprintf(buffer_2, "OP = %d.%d", integer_part_OP, fractional_part_OP);
	//LCD_printAt(0, buffer_2);	

	
	double impedance = (AREF - output_potential) * 1000 / 40; // 40.0mA = 0.04 A;
	
	// metoda stupida de a obtine partea intreaga si partea zecimala a unui numar fara a mai include si alte biblioteci
	//unsigned int integer_part= (int)impedance;
	// 1000 este precizia, adica in acest caz numarul de zerouri ( deci 3 cifre dupa virgula);
	//unsigned int fractional_part = impedance * 1000 - integer_part * 1000;
	
	//char buffer[16];
	//sprintf(buffer, "I = %d.%d", integer_part, fractional_part);
	//LCD_printAt(40, buffer);
	
	return impedance;
}

// pinul PD5 va fi folosit ca interfata pentru utilizator
void init_interrupt_pin(void)
{

	// Activare intreruperi
	sei();
	// Reset registru de intreruperi global
	PCICR = 0;
	// Reset registrul de intreruperi 24:31
	PCMSK3 = 0;
	// Setez pinul PD6 de input
	DDRD &= ~(1 << PD6);
	// Activez pull-up pe PD6
	PORTD |=  (1 << PD6);
	// Activez intrerupere pentru PCMSK3
    PCICR  |= (1 << PCIE3);
	// Activez intrerupere pentru PD5 - PCINT29
    PCMSK3 |= (1 << PCINT30);

	/*PORTD |= (1 << PD7);
	_delay_ms(500);
	PORTD &= ~(1 << PD7);
	_delay_ms(500);
	PORTD |= (1 << PD7);
	_delay_ms(500);
	PORTD &= ~(1 << PD7);
	_delay_ms(500);	
	if((PIND & (1 << PD5)) == 0) {
		while (1) {
		
				PORTD |= (1 << PD7);
				_delay_ms(500);
				PORTD &= ~(1 << PD7);
				_delay_ms(500);
		}
	}*/
}

/* Initiaza receiver-ul , adica pinii A si D precum si ledul LED */
void init_constant_pins(void)
{
	// Setez PD7 ca iesire
	DDRD |= (1 << PD7);
	
	//PA0-4 intrare 
	DDRA &= ~(1 << PA0) &  ~(1 << PA1) & ~(1 << PA2) & ~(1 << PA3) & ~(1 << PA4);
	
	// pe PA0-4 activez pull up
	PORTA |= (1 << PA0) | (1 << PA1) | (1 << PA2) | (1 << PA3) | (1 << PA4);
	
	//PD 0-1 si 4 intrare
	DDRD &= ~(1 << PD0) &  ~(1 << PD1) & ~(1 << PD4);
	
	//pe PD0-1 si 4 activez pull-up
	PORTD |= (1 << PD0) | (1 << PD1) | (1 << PD4);	
	
	// Setez pinul PD6 de input
	//DDRD &= ~(1 << PD6);
	// Activez pull-up pe PD6
	//PORTD |=  (1 << PD6);	

}



//valori pe care PORTB ar trebui sa le aiba pe rand la fiecare iteratie
// daca PORTB la o iteratie nu este egal cu valoarea corespunzatoare iteratiei, inseamna ca exista un scurt
unsigned char no_short_values[8] = {254, 253, 251, 247, 239, 223, 191, 127};


unsigned int check_straight_through(void)
{
	

	unsigned int i = 0;
	
	//cablul nu functioneaza deloc / 100 Mb/s / 1Gb/s
	//daca defectul este la primele 4 fire, atunci nu functioneaza deloc
	//considerente: quality_check = 1 va merge numai pentru standardul T568B, pe care este si testat, adica primul fir care intra in PB 0 si PA 0 este portocaliu cu alb
	unsigned int quality_check = 2;
	
	// pentru a detecta un scurt, vom verifica valoarea lui PORTB inainte si dupa transmiterea unui 0 de catre un PIN
	// in acest fel, daca exista un scurt, valoarea lui PORTB ar trebui sa fie in domeniul de valori de mai sus din 

	for (i = 0; i < 8; i++) {
	
		// mai intai seteaza toti pinii B de trimtere pe intrare 
		DDRB = 0;
		
		// seteaza-i pe toti cu pull-up
		PORTB = 255;
		
		// seteaza pinul i al portului B ca fiind de iesire
		DDRB |= (1 << i);
		
		// trimite 0 pe pinul i al portului B
		PORTB &= ~(1 << i);
		
		//asteapta propagarea in caz de cablu prost
		_delay_ms(10);
		
		switch (i) {
		
		case 0:
			if ( ((PINA & (1 << PA0)) == 0) ) {
				good_paths++;
				good_connections[i] = 1;
			}
			else {
				quality_check = 0;
			}
			break;
		
		case 1:
			if ( ((PINA & (1 << PA1)) == 0) ) {
				good_paths++;
				good_connections[i] = 1;
			}
			else {
				quality_check = 0;
			}
			break;
			
		case 2:
			if ( ((PINA & (1 << PA2)) == 0) ) {
				good_paths++;
				good_connections[i] = 1;
			}
			else {
				quality_check = 0;
			}
			break;
			
		case 3:
			if ( ((PINA & (1 << PA3)) == 0) ) {
				good_paths++;
				good_connections[i] = 1;
			}
			else {
				quality_check = 0;
			}
			break;	
			
		case 4:
			if ( ((PINA & (1 << PA4)) == 0) ) {
				good_paths++;
				good_connections[i] = 1;
			}
			else {
				quality_check = (quality_check == 0)? 0: 1;
			}
			break;
			
		case 5:
			if ( ((PIND & (1 << PD0)) == 0) ) {
				good_paths++;
				good_connections[i] = 1;
			}
			else {
				quality_check = (quality_check == 0)? 0: 1;
			}
			break;
			
		case 6:
			if ( ((PIND & (1 << PD1)) == 0) ) {
				good_paths++;
				good_connections[i] = 1;
			}
			else {
				quality_check = (quality_check == 0)? 0: 1;
			}
			break;	
			
		case 7:
			if ( ((PIND & (1 << PD4)) == 0) ) {
				good_paths++;
				good_connections[i] = 1;
			}
			else {
				quality_check = (quality_check == 0)? 0: 1;
			}
			break;		

		}
		
		// detectie scurt pentru path-ul curentl
		unsigned int j;
		for (j = 0; j < 8; j++) {
			
			if (i == j) {
				continue;
			}
			if ( ((PINB & (1 << j)) == 0) ) {
				//scurt detectat la pinul j;
				shorted_cable = 1;
				shorted_paths[0] = i + 1; // +1 deoarce incepem numaroatoare de la 1, nu de la 0
				shorted_paths[1] = j + 1;
				/*PORTD |= (1 << PD7);
				_delay_ms(500);
				PORTD &= ~(1 << PD7);
				_delay_ms(500);
				PORTD |= (1 << PD7);
				_delay_ms(500);
				PORTD &= ~(1 << PD7);
				_delay_ms(500);*/					
				
				if ( i < 3 && j < 3 ) {
					quality_check = 0;
				//	return quality_check;
				}
				else {
				
				quality_check = 1;
				//return quality_check;
				}
			}
		
		}
		
	}
	return quality_check;

}



unsigned int check_crossover(void)
{

	unsigned int i = 0;
	
	//cablul nu functioneaza deloc / 100 Mb/s / 1Gb/s
	//daca defectul este la primele 4 fire, atunci nu functioneaza deloc
	//considerente: quality_check = 1 va merge numai pentru standardul T568B, pe care este si testat, adica primul fir care intra in PB 0 si PA 0 este portocaliu cu alb
	unsigned int quality_check = 2;
	
	// pentru a detecta un scurt, vom verifica valoarea lui PORTB inainte si dupa transmiterea unui 0 de catre un PIN
	// in acest fel, daca exista un scurt, valoarea lui PORTB ar trebui sa fie in domeniul de valori de mai sus din 

	for (i = 0; i < 8; i++) {
	
		// mai intai seteaza toti pinii B de trimtere pe intrare 
		DDRB = 0;
		
		// seteaza-i pe toti cu pull-up
		PORTB = 255;
		
		// seteaza pinul i al portului B ca fiind de iesire
		DDRB |= (1 << i);
		
		// trimite 0 pe pinul i al portului B
		PORTB &= ~(1 << i);
		
		//asteapta propagarea in caz de cablu prost
		_delay_ms(10);
		
		switch (i) {
		
		case 0:
			if ( ((PINA & (1 << PA2)) == 0) ) {
				good_paths++;
				good_connections[i] = 1;
			}
			else {
				quality_check = 0;
			}
			break;
		
		case 1:
			if ( ((PIND & (1 << PD0)) == 0) ) {
				good_paths++;
				good_connections[i] = 1;
			}
			else {
				quality_check = 0;
			}
			break;
			
		case 2:
			if ( ((PINA & (1 << PA0)) == 0) ) {
				good_paths++;
				good_connections[i] = 1;
			}
			else {
				quality_check = 0;
			}
			break;
			
		case 3:
			if ( ((PINA & (1 << PA3)) == 0) ) {
				good_paths++;
				good_connections[i] = 1;
			}
			else {
				quality_check = 0;
			}
			break;	
			
		case 4:
			if ( ((PINA & (1 << PA4)) == 0) ) {
				good_paths++;
				good_connections[i] = 1;
			}
			else {
				quality_check = (quality_check == 0)? 0: 1;
			}
			break;
			
		case 5:
			if ( ((PINA & (1 << PA1)) == 0) ) {
				good_paths++;
				good_connections[i] = 1;
			}
			else {
				quality_check = (quality_check == 0)? 0: 1;
			}
			break;
			
		case 6:
			if ( ((PIND & (1 << PD1)) == 0) ) {
				good_paths++;
				good_connections[i] = 1;
			}
			else {
				quality_check = (quality_check == 0)? 0: 1;
			}
			break;	
			
		case 7:
			if ( ((PIND & (1 << PD4)) == 0) ) {
				good_paths++;
				good_connections[i] = 1;
			}
			else {
				quality_check = (quality_check == 0)? 0: 1;
			}
			break;		

		}
		
		// detectie scurt pentru path-ul curent
		unsigned int j;
		for (j = 0; j < 8; j++) {
			
			if (i == j) {
				continue;
			}
			if ( ((PINB & (1 << j)) == 0) ) {
				//scurt detectat la pinul j;
				shorted_cable = 1;
				shorted_paths[0] = i + 1; // +1 deoarce incepem numaroatoare de la 1, nu de la 0
				shorted_paths[1] = j + 1;
				/*PORTD |= (1 << PD7);
				_delay_ms(500);
				PORTD &= ~(1 << PD7);
				_delay_ms(500);
				PORTD |= (1 << PD7);
				_delay_ms(500);
				PORTD &= ~(1 << PD7);
				_delay_ms(500);*/					
				
				if ( i < 3 && j < 3) {
					quality_check = 0;
					//return quality_check;
				}
				else {
				
				quality_check = 1;
				//return quality_check;
				}
			}
		
		}
	}
	return quality_check;
}





unsigned int check_rollover(void)
{

unsigned int i = 0;
	
	//cablul nu functioneaza deloc / 100 Mb/s / 1Gb/s
	//daca defectul este la primele 4 fire, atunci nu functioneaza deloc
	//considerente: quality_check = 1 va merge numai pentru standardul T568B, pe care este si testat, adica primul fir care intra in PB 0 si PA 0 este portocaliu cu alb
	unsigned int quality_check = 2;
	
	// pentru a detecta un scurt, vom verifica valoarea lui PORTB inainte si dupa transmiterea unui 0 de catre un PIN
	// in acest fel, daca exista un scurt, valoarea lui PORTB ar trebui sa fie in domeniul de valori de mai sus din 

	for (i = 0; i < 8; i++) {
	
		// mai intai seteaza toti pinii B de trimtere pe intrare 
		DDRB = 0;
		
		// seteaza-i pe toti cu pull-up
		PORTB = 255;
		
		// seteaza pinul i al portului B ca fiind de iesire
		DDRB |= (1 << i);
		
		// trimite 0 pe pinul i al portului B
		PORTB &= ~(1 << i);
		
		//asteapta propagarea in caz de cablu prost
		_delay_ms(10);
		
		switch (i) {
		
		case 0:
			if ( ((PIND & (1 << PD4)) == 0) ) {
				good_paths++;
				good_connections[i] = 1;
			}
			else {
				quality_check = 0;
			}
			break;
		
		case 1:
			if ( ((PIND & (1 << PD1)) == 0) ) {
				good_paths++;
				good_connections[i] = 1;
			}
			else {
				quality_check = 0;
			}
			break;
			
		case 2:
			if ( ((PIND & (1 << PD0)) == 0) ) {
				good_paths++;
				good_connections[i] = 1;
			}
			else {
				quality_check = 0;
			}
			break;
			
		case 3:
			if ( ((PINA & (1 << PA4)) == 0) ) {
				good_paths++;
				good_connections[i] = 1;
			}
			else {
				quality_check = 0;
			}
			break;	
			
		case 4:
			if ( ((PINA & (1 << PA3)) == 0) ) {
				good_paths++;
				good_connections[i] = 1;
			}
			else {
				quality_check = (quality_check == 0)? 0: 1;
			}
			break;
			
		case 5:
			if ( ((PINA & (1 << PA2)) == 0) ) {
				good_paths++;
				good_connections[i] = 1;
			}
			else {
				quality_check = (quality_check == 0)? 0: 1;
			}
			break;
			
		case 6:
			if ( ((PINA & (1 << PA1)) == 0) ) {
				good_paths++;
				good_connections[i] = 1;
			}
			else {
				quality_check = (quality_check == 0)? 0: 1;
			}
			break;	
			
		case 7:
			if ( ((PINA & (1 << PA0)) == 0) ) {
				good_paths++;
				good_connections[i] = 1;
			}
			else {
				quality_check = (quality_check == 0)? 0: 1;
			}
			break;		

		}
		
		// cand e un scurt, nici nu mai ai ce sa faci la cablu, deci 
		// nu are sens identificarea locului unde se face scurtul
		if (PORTB != no_short_values[i]) {
		
			shorted_cable = 1;
			
			if ( i <= 3 ) {
				quality_check = 0;
				return quality_check;
			}
			else {
				
				quality_check = 1;
				return quality_check;
			}
		}
	}
	return quality_check;

}


int check_type(void)
{
	// mai intai seteaza toti pinii B de trimtere pe intrare 
	DDRB = 0;
	
	// seteaza-i pe toti cu pull-up
	PORTB = 255;
	
	// seteaza pinul 0 al portului B ca fiind de iesire
	DDRB |= (1 << 0);
	
	// trimite 0 pe pinul 0 al portului B
	PORTB &= ~(1 << 0);
	
	_delay_ms(10);
	
	//a primit la PA0, e straight
	if ( ((PINA & (1 << PA0)) == 0) ) {
		
		return 1;
	}
	
	//a primit la PA2, e crossover
	else if ( ((PINA & (1 << PA2)) == 0) ) {
		return 2;
	}
	
	//trebuie facut si pentru rollover
	
	//n-a primit unde trebuie, e total aiurea legat, deci nu recunoaste tip
	else if ( PINA != 255 ) {
		return -2;
	}
	
	//conexiune deschisa pe primul pin
	else {
		return -1;
	}

}



// main testing function
// verificarea de scurt circuit se face numai pentru quality 0 sau 1, ca daca quality = 2, atunci clar e bun si nu e scurtcircuitat
void test_cable(void)
{
	// quality = 2 = 1Gb/s, quality = 1 = 100Mb/s, quality = 0 = nefunctional 
	unsigned int quality = 2;
	// type = 0 = straight, type = 1 = crossover, type = -1 = nefunctional deloc, conexiune libera pe fix primul pin, type = -2 = nu recunoaste cablajul
	int type;
	unsigned int current_status = -1;
	double impedance = 0;
	unsigned int impedance_integer_part = 0;
	unsigned int impedance_fractional_part = 0;
	
	init_interrupt_pin();
	init_constant_pins();
	
	type = check_type();
	
	if (type == 1) {
		quality = check_straight_through();
		//PORTD |= (1 << PD7);
	}
	else if (type == 2) {
		quality = check_crossover();
		
		/*
		PORTD |= (1 << PD7);
		_delay_ms(500);
		PORTD &= ~(1 << PD7);
		_delay_ms(500);
		PORTD |= (1 << PD7);
		_delay_ms(500);
		PORTD &= ~(1 << PD7);
		_delay_ms(500);
		*/
		
	}
	
	//conexiune libera pe primul pin
	else if (type == -1) {
		quality = 0;
	}
	
	// tip necunoscut
	else if (type == -2) {		
		quality = 0;
	}
	
	//nu ar trebui sa ajunga aici
	else {
		quality = 0;
	}
	
	//TODO: numarat cate conexiuni libere sunt si unde si cum in functie de pin dintr-o parte a cablului si pe cealalta in functie de itp
	//TODO: verificat si scurturi intre fire DONE
	//TODO: printat stare cablu ( conexiuni libere/ daca e scurt-circuitat sau nu/ daca e straight/cross, si calitatea lui )

	if (quality != 0) {
	
		impedance = get_impedance(type);
		// metoda stupida de a obtine partea intreaga si partea zecimala a unui numar fara a mai include si alte biblioteci
		impedance_integer_part= (int)impedance;
		// 1000 este precizia, adica in acest caz numarul de zerouri ( deci 3 cifre dupa virgula);
		impedance_fractional_part = impedance * 1000 - impedance_integer_part * 1000;		
	}	
	
	if (quality == 2) {
		
		
		//LCD_print("Full ");
		//LCD_printAt(40, "connection!");
		//aprinde ledul LED
		//PORTD |= (1 << PD7);
		while (1) {
			
			/*if((PIND & (1 << PD6)) == 0) {
				PORTD &= ~(1 << PD7);
				//_delay_ms(500);
				//PORTD |= (1 << PD7);
				//_delay_ms(500);				
			}
			else {
				PORTD |= (1 << PD7);
			}*/
			
			if (status == current_status) {
			
			}
			
			else {
				current_status = status;
				if (current_status == 0 ) {
					LCD_writeInstr(LCD_INSTR_clearDisplay);
					LCD_print("Full ");
					LCD_printAt(40, "connection!");				
			
				}
				else if (current_status == 1) {
				
					if (type == 1) {
						LCD_writeInstr(LCD_INSTR_clearDisplay);
						LCD_print(mess_cable_is_wired);
						LCD_printAt(40, "straight-through");						
						
					}
					else if (type == 2) {
						LCD_writeInstr(LCD_INSTR_clearDisplay);
						LCD_print(mess_cable_is_wired);
						LCD_printAt(40, "crossover");							
					}
					else if (type == 3) {
						LCD_writeInstr(LCD_INSTR_clearDisplay);
						LCD_print(mess_cable_is_wired);
						LCD_printAt(40, "rollover");							
					}
					// nu ar trebui sa intre aici
					else {
						LCD_writeInstr(LCD_INSTR_clearDisplay);
						//LCD_print("Should not");
						//LCD_printAt(40, "get here");	
					}
				}
				else if (current_status == 2) {
					LCD_writeInstr(LCD_INSTR_clearDisplay);
					LCD_print("Cable maximum");
					LCD_printAt(40, "speed is 1Gb/s");						
				}
				else if (current_status == 3) {
					LCD_writeInstr(LCD_INSTR_clearDisplay);
					LCD_print(mess_dc_loop_resistance);
					char buffer[16];
					sprintf(buffer,"%d.%d ohms", impedance_integer_part, impedance_fractional_part);
					LCD_printAt(40, buffer);	
				}
				else if (current_status == 4) {
					unsigned int quality_factor = impedance / REFERENCE_DC_LOOP_RESISTANCE;
					LCD_writeInstr(LCD_INSTR_clearDisplay);
					LCD_print("Ok if cable has");
					char buffer[16];
					sprintf(buffer, "more than %d m", quality_factor);
					LCD_printAt(40, buffer);
				}
				else if (current_status == 5) {
					LCD_writeInstr(LCD_INSTR_clearDisplay);
					LCD_print(mess_press_again);
					LCD_printAt(40, mess_for_new_test);						
				}
				else {
					break;
				}
			}
		}		
		
	
	}
	else if (quality == 1) {
	
		//aprinde si stinge LED-ul
		//PORTD |= (1 << PD7);
		//_delay_ms(500);
		//PORTD &= ~(1 << PD7);
		//_delay_ms(500);
		//PORTD |= (1 << PD7);
		//_delay_ms(500);
		//PORTD &= ~(1 << PD7);
		//_delay_ms(500);			
		while (1) {

			if (status == current_status) {
			
			}
			
			else {
				current_status = status;
				if (current_status == 0 ) {
					LCD_writeInstr(LCD_INSTR_clearDisplay);
					LCD_print("Partial ");
					LCD_printAt(40, "connection!");				
			
				}
				else if (current_status == 1) {
				
					if (type == 1) {
						LCD_writeInstr(LCD_INSTR_clearDisplay);
						LCD_print(mess_cable_is_wired);
						LCD_printAt(40, "straight-through");						
						
					}
					else if (type == 2) {
						LCD_writeInstr(LCD_INSTR_clearDisplay);
						LCD_print(mess_cable_is_wired);
						LCD_printAt(40, "crossover");							
					}
					else if (type == 3) {
						LCD_writeInstr(LCD_INSTR_clearDisplay);
						LCD_print(mess_cable_is_wired);
						LCD_printAt(40, "rollover");							
					}
					// nu ar trebui sa intre aici
					else {
						LCD_writeInstr(LCD_INSTR_clearDisplay);
						//LCD_print("Should not");
						//LCD_printAt(40, "get here");	
					}
				}
				else if (current_status == 2) {
					LCD_writeInstr(LCD_INSTR_clearDisplay);
					LCD_print("Cable maximum");
					LCD_printAt(40, "speed is 100Mb/s");						
				}
				else if (current_status == 3) {
					if (shorted_cable == 1) {
						LCD_writeInstr(LCD_INSTR_clearDisplay);
						char buffer[16];
						sprintf(buffer, "Paths %d and %d", shorted_paths[0], shorted_paths[1]);
						LCD_print(buffer);
						LCD_printAt(40, mess_short_circuited);
						shorted_cable = 0;	
						
					}
					else {
						status += 1;
					}
				}

				else if (current_status == 4) {
				
					unsigned int j = 0;
					unsigned int bad_connections = 0; // daca 2-3-4 nu merg, atunci va afisa 234
					for (j = 0 ; j < 8; j++ ) {
					
						if (good_connections[j] == 0) {
							
							// j+1 pentru ca avem conexiunea 0 in program, dar pe lcd trebuie scris 1
							bad_connections = bad_connections * 10 + (j + 1);
						}
					}
					LCD_writeInstr(LCD_INSTR_clearDisplay);
					if (bad_connections == 0) {
						LCD_print("No open");
						LCD_printAt(40,"connections");
					}
					else {
						LCD_print("Open connections:");
						char buffer[16];
						sprintf(buffer,"%d", bad_connections);
						LCD_printAt(40, buffer);	
					}
					
				
				}
				else if (current_status == 5) {
					LCD_writeInstr(LCD_INSTR_clearDisplay);
					LCD_print(mess_dc_loop_resistance);
					char buffer[16];
					sprintf(buffer,"%d.%d ohms", impedance_integer_part, impedance_fractional_part);
					LCD_printAt(40, buffer);	
				}
				else if (current_status == 6) {
					unsigned int quality_factor = impedance / REFERENCE_DC_LOOP_RESISTANCE;
					LCD_writeInstr(LCD_INSTR_clearDisplay);
					LCD_print("Ok if cable has");
					char buffer[16];
					sprintf(buffer, "more than %d m", quality_factor);
					LCD_printAt(40, buffer);
				}
				else if (current_status == 7) {
					LCD_writeInstr(LCD_INSTR_clearDisplay);
					LCD_print(mess_press_again);
					LCD_printAt(40, mess_for_new_test);						
				}
				else {
					break;
				}
			}			
		}	
	}
	else {
	
		//LCD_printAt(40, "connection! :(");
		//while (1) {
		//	PORTD |= (1 << PD7);
		//	_delay_ms(2000);
		//	PORTD &= ~(1 << PD7);
		//	_delay_ms(2000);
		//}
		while (1) {
			if (status == current_status) {
			
			}
			
			else {
				current_status = status;
				if (current_status == 0 ) {
					LCD_writeInstr(LCD_INSTR_clearDisplay);
					LCD_print("No connection ");
					LCD_printAt(40, "available :( !");				
			
				}
				else if (current_status == 1) {
					if (shorted_cable == 1) {
						LCD_writeInstr(LCD_INSTR_clearDisplay);
						char buffer[16];
						sprintf(buffer, "Paths %d and %d", shorted_paths[0], shorted_paths[1]);
						LCD_print(buffer);
						LCD_printAt(40, mess_short_circuited);
						shorted_cable = 0;	
						
					}
					else {
						status += 1;
					}
				}
				else if (current_status == 2) {
				
					unsigned int j = 0;
					unsigned long bad_connections = 0; // daca 2-3-4 nu merg, atunci va afisa 234
					for (j = 0 ; j < 8; j++ ) {
					
						if (good_connections[j] == 0) {
							
							// j+1 pentru ca avem conexiunea 0 in program, dar pe lcd trebuie scris 1
							bad_connections = bad_connections * 10 + (j + 1);
						}
					}
					LCD_writeInstr(LCD_INSTR_clearDisplay);
					LCD_print("Open connections:");
					char buffer[16];
					sprintf(buffer,"%lu", bad_connections);
					LCD_printAt(40, buffer);						
			
				
				}
				else if (current_status == 3){

					LCD_writeInstr(LCD_INSTR_clearDisplay);
					LCD_print("No other data");
					LCD_printAt(40, "can be obtained");
								
				}
				else if (current_status == 4) {	
					LCD_writeInstr(LCD_INSTR_clearDisplay);
					LCD_print(mess_press_again);
					LCD_printAt(40, mess_for_new_test);						
				}				
				else {
					break;
				}
			}
		}
	}
	status = 0;
	shorted_cable = 0;
	good_paths = 0;
	unsigned int j;
	for (j = 0; j < 8; j++) {
		good_connections[j] = 0;
	}
	/*while (1) {

		//do nothing
	}*/

}


int main(void) {
	//exemplu();
	//exemplu_test_cablu();
	LCD_init();
	LCD_writeInstr(LCD_INSTR_clearDisplay);
	//LCD_print("Ceva");
	//get_impedance(1);
	
	
	while (1) {
		test_cable();
	}
	
	return 0;
}
